Bug 1325378 - Review Request: spasm-ng - A z80 assembler with extra features for TI calculators
Summary: Review Request: spasm-ng - A z80 assembler with extra features for TI calcula...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: gil cattaneo
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-04-08 15:40 UTC by Ben Rosser
Modified: 2016-09-18 10:19 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-09-04 17:39:02 UTC
puntogil: fedora-review+


Attachments (Terms of Use)

Description Ben Rosser 2016-04-08 15:40:44 UTC
Spec URL: https://tc01.fedorapeople.org/spasm/spasm-ng.spec
SRPM URL: https://tc01.fedorapeople.org/spasm/spasm-ng-0.5-0.2.beta.2.fc23.src.rpm

Description:
SPASM-ng is a z80 assembler with extra features to support development
for TI calculators. SPASM-ng can assemble and create assembly programs
and flash applications in formats that can be shipped directly to
TI-z80 (TI-83+, TI-83+SE, TI-84+, TI-83+SE, TI-84+CSE, TI-84+CE)
calculators.

SPASM-ng was originally from the SPASM project, and was forked to fix
a few bugs. It was originally written by Spencer Putt and Don Straney,
with additional development by Chris Shappell and James Montelongo.

This release incorporates eZ80 support in preparation for the launch
of the TI-84+CE. It also greatly increases the limit on the number
of labels that can be defined.

Fedora Account System Username: tc01

Some notes:

* spasm-ng is available in this COPR (https://copr.fedorainfracloud.org/coprs/tc01/spasm-ng/) if you wish to test it.

* spasm-ng is distributed upstream alongside some z80 assembly include files, for linking against the TI-83+. Where should these be distributed? I've put them into /usr/include/spasm-ng, which feels like... not quite the right place, but I'm not sure if .../share/ makes any more sense.

* One of these files (https://github.com/alberthdev/spasm-ng/blob/master/inc/ti83plus.inc) was originally written by TI, and I'm not certain we (Fedora) can legally redistribute it. If necessary, it can be removed from the package. On the other hand, the included license text seems only to establish the file is under no warranty and that its copyright notice be left intact, and the calculator hacking community has redistributed this file for years. (Though that obviously doesn't mean Fedora can ship it).

Comment 1 Ben Rosser 2016-07-19 23:53:22 UTC
Having thought about the include file situation further... I believe they probably should be removed from the package:

Their authorship and copyright is difficult to assert (most of the community written files are not licensed, and ti83plus.inc was originally written by TI and then heavily modified), most authors of TI calculator assembly projects bundle them with their code anyway, and spasm does not expect include files to be available system-wide to begin with. The AUR package for Arch makes a similar decision and does not include them.

I have also realized the package was not being built with system-wide ldflags, so I fixed that and reuploaded the package.

Spec URL: https://tc01.fedorapeople.org/spasm/spasm-ng.spec
SRPM URL: https://tc01.fedorapeople.org/spasm/spasm-ng-0.5-0.3.beta.2.fc23.src.rpm

I believe it is now ready for review.

Comment 2 gil cattaneo 2016-08-27 08:47:27 UTC
can you take this https://bugzilla.redhat.com/show_bug.cgi?id=1366839 for me?

Comment 3 gil cattaneo 2016-08-27 08:50:15 UTC
Please, remove rm -rf %{buildroot} in %install section

Comment 4 gil cattaneo 2016-08-27 08:56:49 UTC
I get Error 404 downloading https://tc01.fedorapeople.org/spasm/spasm-ng-0.5-0.3.beta.2.fc23.src.rpm
please, fix also the problem reported above

Comment 5 Ben Rosser 2016-08-27 16:47:12 UTC
Oh, whoops. The correct SRPM is fc24, not fc23:

Spec URL: https://tc01.fedorapeople.org/spasm/spasm-ng.spec
SRPM URL: https://tc01.fedorapeople.org/spasm/spasm-ng-0.5-0.3.beta.2.fc24.src.rpm

I will fix the rm -rf %{buildroot} as well.

Comment 6 gil cattaneo 2016-08-27 16:58:38 UTC
(In reply to Ben Rosser from comment #5)

> I will fix the rm -rf %{buildroot} as well.

It is still there ...

Comment 7 gil cattaneo 2016-08-27 17:22:02 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[!]: Package contains no static executables.

 ./lib/x64/mpir.lib
 ./lib/x64/mpir.pdb
 ./lib/mpir.lib
 ./lib/mpir.pdb
 Please, remove
 
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (3 clause)", "LGPL (v2.1 or later) (with incorrect FSF
     address)", "GPL (v2 or later)", "Unknown or generated". 53 files have
     unknown license. Detailed output of licensecheck in /home/gil/1325378
     -spasm-ng/licensecheck.txt

 ./gmp.h LGPL (v2.1 or later) (with incorrect FSF address)
 ./modp_ascii.cpp BSD ./modp_ascii.h (3 clause)
 The remain source code is without license headers.
 Please, report the problem to upstream and ask to add the license header where are missing
 https://fedoraproject.org/wiki/Packaging:LicensingGuidelines?rd=Packaging/LicensingGuidelines#License_Clarification

[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[!]: Package contains no bundled libraries without FPC exception.

 Please, add:
 GNU MP Library ./gmp.h
 Provides:   bundled(gmp) = [unknown version]
 http://code.google.com/p/stringencoders/ ./modp_ascii.cpp BSD ./modp_ascii.h
 Provides:   bundled(stringencoders) = [unknown version]
 i dont known the version this libraries. Please replace "[unknown version]" with an appropriate value
 
 
[x]: Changelog in prescribed format.
[!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
[?]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in spasm-
     ng-debuginfo
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: spasm-ng-0.5-0.3.beta.2.fc26.i686.rpm
          spasm-ng-debuginfo-0.5-0.3.beta.2.fc26.i686.rpm
          spasm-ng-0.5-0.3.beta.2.fc26.src.rpm
spasm-ng.i686: W: no-manual-page-for-binary spasm
spasm-ng.src:55: W: macro-in-comment %{buildroot}
spasm-ng.src:55: W: macro-in-comment %{_includedir}
spasm-ng.src:55: W: macro-in-comment %{name}
spasm-ng.src:56: W: macro-in-comment %{buildroot}
spasm-ng.src:56: W: macro-in-comment %{_includedir}
spasm-ng.src:56: W: macro-in-comment %{name}
spasm-ng.src:60: W: macro-in-comment %{_includedir}
3 packages and 0 specfiles checked; 0 errors, 8 warnings.

Please, cleanup spec file



Rpmlint (debuginfo)
-------------------
Checking: spasm-ng-debuginfo-0.5-0.3.beta.2.fc26.i686.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
spasm-ng.i686: W: no-manual-page-for-binary spasm
2 packages and 0 specfiles checked; 0 errors, 1 warnings.



Requires
--------
spasm-ng (rpmlib, GLIBC filtered):
    libc.so.6
    libcrypto.so.10
    libcrypto.so.10(libcrypto.so.10)
    libgcc_s.so.1
    libgmp.so.10
    libm.so.6
    libstdc++.so.6
    libstdc++.so.6(CXXABI_1.3.9)
    rtld(GNU_HASH)

spasm-ng-debuginfo (rpmlib, GLIBC filtered):



Provides
--------
spasm-ng:
    spasm-ng
    spasm-ng(x86-32)

spasm-ng-debuginfo:
    spasm-ng-debuginfo
    spasm-ng-debuginfo(x86-32)



Source checksums
----------------
https://github.com/alberthdev/spasm-ng/archive/v0.5-beta.2/spasm-ng-0.5-beta.2.tar.gz :
  CHECKSUM(SHA256) this package     : b354a22706a9d82dbce9deec10f06186dcbc2faf3f25e31cc8674543121b3d60
  CHECKSUM(SHA256) upstream package : b354a22706a9d82dbce9deec10f06186dcbc2faf3f25e31cc8674543121b3d60


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1325378 --plugins C/C++ -m fedora-rawhide-i386
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 8 gil cattaneo 2016-08-27 17:23:36 UTC
Issues:


[reply] [−] Description Ben Rosser 2016-04-08 11:40:44 EDT
Spec URL: https://tc01.fedorapeople.org/spasm/spasm-ng.spec
SRPM URL: https://tc01.fedorapeople.org/spasm/spasm-ng-0.5-0.2.beta.2.fc23.src.rpm

Description:
SPASM-ng is a z80 assembler with extra features to support development
for TI calculators. SPASM-ng can assemble and create assembly programs
and flash applications in formats that can be shipped directly to
TI-z80 (TI-83+, TI-83+SE, TI-84+, TI-83+SE, TI-84+CSE, TI-84+CE)
calculators.

SPASM-ng was originally from the SPASM project, and was forked to fix
a few bugs. It was originally written by Spencer Putt and Don Straney,
with additional development by Chris Shappell and James Montelongo.

This release incorporates eZ80 support in preparation for the launch
of the TI-84+CE. It also greatly increases the limit on the number
of labels that can be defined.

Fedora Account System Username: tc01

Some notes:

* spasm-ng is available in this COPR (https://copr.fedorainfracloud.org/coprs/tc01/spasm-ng/) if you wish to test it.

* spasm-ng is distributed upstream alongside some z80 assembly include files, for linking against the TI-83+. Where should these be distributed? I've put them into /usr/include/spasm-ng, which feels like... not quite the right place, but I'm not sure if .../share/ makes any more sense.

* One of these files (https://github.com/alberthdev/spasm-ng/blob/master/inc/ti83plus.inc) was originally written by TI, and I'm not certain we (Fedora) can legally redistribute it. If necessary, it can be removed from the package. On the other hand, the included license text seems only to establish the file is under no warranty and that its copyright notice be left intact, and the calculator hacking community has redistributed this file for years. (Though that obviously doesn't mean Fedora can ship it).
[reply] [−] Comment 1 Ben Rosser 2016-07-19 19:53:22 EDT
Having thought about the include file situation further... I believe they probably should be removed from the package:

Their authorship and copyright is difficult to assert (most of the community written files are not licensed, and ti83plus.inc was originally written by TI and then heavily modified), most authors of TI calculator assembly projects bundle them with their code anyway, and spasm does not expect include files to be available system-wide to begin with. The AUR package for Arch makes a similar decision and does not include them.

I have also realized the package was not being built with system-wide ldflags, so I fixed that and reuploaded the package.

Spec URL: https://tc01.fedorapeople.org/spasm/spasm-ng.spec
SRPM URL: https://tc01.fedorapeople.org/spasm/spasm-ng-0.5-0.3.beta.2.fc23.src.rpm

I believe it is now ready for review.
[reply] [−] Comment 2 gil cattaneo 2016-08-27 04:47:27 EDT
can you take this https://bugzilla.redhat.com/show_bug.cgi?id=1366839 for me?
Assignee: nobody@fedoraproject.orgpuntogil@libero.it
Flags: fedora-review?
[reply] [−] Comment 3 gil cattaneo 2016-08-27 04:50:15 EDT
Please, remove rm -rf %{buildroot} in %install section
[reply] [−] Comment 4 gil cattaneo 2016-08-27 04:56:49 EDT
I get Error 404 downloading https://tc01.fedorapeople.org/spasm/spasm-ng-0.5-0.3.beta.2.fc23.src.rpm
please, fix also the problem reported above
[reply] [−] Comment 5 Ben Rosser 2016-08-27 12:47:12 EDT
Oh, whoops. The correct SRPM is fc24, not fc23:

Spec URL: https://tc01.fedorapeople.org/spasm/spasm-ng.spec
SRPM URL: https://tc01.fedorapeople.org/spasm/spasm-ng-0.5-0.3.beta.2.fc24.src.rpm

I will fix the rm -rf %{buildroot} as well.
[reply] [−] Comment 6 gil cattaneo 2016-08-27 12:58:38 EDT
(In reply to Ben Rosser from comment #5)

> I will fix the rm -rf %{buildroot} as well.

It is still there ...
[reply] [−] Comment 7 gil cattaneo 2016-08-27 13:22:02 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[!]: Package contains no static executables.

 ./lib/x64/mpir.lib
 ./lib/x64/mpir.pdb
 ./lib/mpir.lib
 ./lib/mpir.pdb
 Please, remove

[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (3 clause)", "LGPL (v2.1 or later) (with incorrect FSF
     address)", "GPL (v2 or later)", "Unknown or generated". 53 files have
     unknown license. Detailed output of licensecheck in /home/gil/1325378
     -spasm-ng/licensecheck.txt

 ./gmp.h LGPL (v2.1 or later) (with incorrect FSF address)
 ./modp_ascii.cpp BSD ./modp_ascii.h (3 clause)
 The remain source code is without license headers.
 Please, report the problem to upstream and ask to add the license header where are missing
 https://fedoraproject.org/wiki/Packaging:LicensingGuidelines?rd=Packaging/LicensingGuidelines#License_Clarification

[!]: Package contains no bundled libraries without FPC exception.

 Please, add:
 GNU MP Library ./gmp.h
 Provides:   bundled(gmp) = [unknown version]
 http://code.google.com/p/stringencoders/ ./modp_ascii.cpp BSD ./modp_ascii.h
 Provides:   bundled(stringencoders) = [unknown version]
 i dont known the version this libraries. Please replace "[unknown version]" with an appropriate value

[!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required

Comment 9 Ben Rosser 2016-08-30 00:56:28 UTC
I've removed the static libs as part of the %prep stage (they weren't being used as part of the compile process anyway but this way we can be sure of that).

I've removed the gmp.h header; spasm links against a system-wide gmp instead so it doesn't really need that header file anyway.

The stringencoders sources... sigh. I managed to not notice those initially, my bad. I think I am going to eventually have a go at properly unbundling this and packaging stringencoders separately. 

For now, though... stringencoders does not seem to actually believe in release versions that aren't just a date; if you look at the changelog here, for instance: https://github.com/client9/stringencoders/blob/master/ChangeLog. The sources were added to spasm (pre-spasm-ng fork) on 8/20/2011; https://wabbit.codeplex.com/SourceControl/changeset/69815. My best guess at a version, then, would be "19-Mar-2010". Should I stylize this as 2010.03.19, should I use the date the files were added (2011.08.20), or do something different? (For now, I've used 2011.08.20, since that would be the date the files were pulled).

I have opened an issue upstream asking for license clarification / license headers. https://github.com/alberthdev/spasm-ng/issues/37.

And I have removed the rm -rf %{buildroot}.

Spec URL: https://tc01.fedorapeople.org/spasm/spasm-ng.spec
SRPM URL: https://tc01.fedorapeople.org/spasm/spasm-ng-0.5-0.4.beta.2.fc24.src.rpm

Comment 10 Ben Rosser 2016-08-30 00:58:04 UTC
Oh, my bad, I forgot to amend the License tag to reflect the bundling too. Updated; not bumping the release for this change:

Spec URL: https://tc01.fedorapeople.org/spasm/spasm-ng.spec
SRPM URL: https://tc01.fedorapeople.org/spasm/spasm-ng-0.5-0.4.beta.2.fc24.src.rpm

Comment 11 gil cattaneo 2016-08-30 01:11:13 UTC
Approved

Comment 12 Ben Rosser 2016-08-30 01:31:03 UTC
Thanks!

Comment 13 Gwyn Ciesla 2016-08-30 12:24:11 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/spasm-ng

Comment 14 Fedora Update System 2016-08-30 19:30:00 UTC
spasm-ng-0.5-0.4.beta.2.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2016-77c655576c

Comment 15 Fedora Update System 2016-08-30 19:30:30 UTC
spasm-ng-0.5-0.4.beta.2.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-7b735b0d04

Comment 16 Fedora Update System 2016-08-30 19:31:22 UTC
spasm-ng-0.5-0.4.beta.2.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-4f36d66bea

Comment 17 Fedora Update System 2016-08-30 19:32:13 UTC
spasm-ng-0.5-0.4.beta.2.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-44179d64eb

Comment 18 Fedora Update System 2016-08-31 15:18:55 UTC
spasm-ng-0.5-0.4.beta.2.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-44179d64eb

Comment 19 Fedora Update System 2016-08-31 16:23:32 UTC
spasm-ng-0.5-0.4.beta.2.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-77c655576c

Comment 20 Fedora Update System 2016-09-04 17:39:00 UTC
spasm-ng-0.5-0.4.beta.2.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 21 Fedora Update System 2016-09-09 16:53:20 UTC
spasm-ng-0.5-0.4.beta.2.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Comment 22 Fedora Update System 2016-09-09 16:54:42 UTC
spasm-ng-0.5-0.4.beta.2.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 23 Fedora Update System 2016-09-18 10:19:35 UTC
spasm-ng-0.5-0.4.beta.2.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.